;A SuperBasic extension procedure by Ian Bruntlett
;By the way this junk has a 
;RENUM_FILE Source$,Destination$,Line_Number,Line_inc
MT_INF EQU $000
IO_OPEN EQU $001
IO_CLOSE EQU $002
IO_FBYTE EQU $001
IO_SBYTE EQU $005
IO_SSTRG EQU $007
BV_CHBAS EQU $030
BV_CHP EQU $034
BV_RIP EQU $058
CN_ITOD EQU $0F2
BP_INIT EQU $110
CA_GTINT EQU $112
CA_GTSTR EQU $116
BV_CHRIX EQU $11A
ERR_NO EQU -006
ERR_BP EQU -015
ERR_EF EQU -010
;Initialise the routine
MOVE.W  BP_INIT,A2
LEA.L   proc_def,A1
JMP     (A2)

proc_def
DC.W    1                       ;Number of procedures
DC.W    R_F-*                   ;Relative pointer to routine
DC.B    10,"RENUM_FILE",0       ;Length,Name,Padding
DC.W    0                       ;End of procdeures
DC.W    0                       ;No functions
DC.W    0                       ;End of functions

;First check for four parameters
R_F MOVEQ #ERR_BP,D0 ;Set error as BAD PARAMETER
MOVE.L A5,D1 ;D1=SB param ptr
SUB.L A3,D1 ;D1=Number of parameters x 8
CMPI.B #32,D1 ;Compare D1 with 4x8
BNE err_end ;If error then end

;Check that ten bytes are available on arithmetic stack (only need 8)
MOVEQ #8,D1 ;Set number of bytes required
MOVE.W BV_CHRIX,A0 ;Get vector
JSR (A0) ;Allocate space on RI stack
MOVE.L BV_RIP(A6),A1 ;Update A1 as RI SP
MOVE.L A1,D4
SUBQ #8,D4 ;Save workspace address in D4

;1(a). Now get channel Ids for source & destination
LEA.L 8(A3),A5 ;Hide the other three params
MOVEQ #1,D3 ;Open old (shared) file

;2(a). Open input channel
;Filename at 0(A6,A1.L)
BSR OPENER                  ;Get the source channel Id
BNE err_end                 ;If error then end
;& Return with error as subroutine was BRAnched to
MOVE.W D2,D5                   ;Set # presence flag
SWAP D5                      ;Save flag in upper word
;(b)  Save input channel ID
MOVE.L A0,A2
;OPEN output channel

;Will first have to skip past the first string on the RI stack
ADDA.W 0(A6,A1.L),A1 ;A1=A1+Length of string
ADDQ #3,A1 ;+2 to get past len
MOVE.L A1,D7 ;Cannot AND an address reg
AND.W #$FFFE,D7 ;+1 ANDed with $FE evens UP
MOVE.L D7,A1 ;Put ANDed result in A1
MOVE.L A5,A3 ;Adjust parameter ptrs
ADDQ #8,A5 ;to point to next parameter
;Now 0(A6,A1.L) points to the top of stack
MOVEQ #2,D3 ;Open new (exclusive) file
BSR OPENER ;Get the destination chan Id
BNE Clo_src ;If error then close channel
;So end with error as BRAnched to a subroutine
MOVE.W D2,D5 ;Save # presence flag
;(c)  Save output channel ID
MOVE.L D7,A1 ;Restore RI SP
MOVE.L A0,A4 ;Save output channel ID in A4

;Get two integer parameters
MOVE.L A5,A3 ;Update first param ptr
ADDQ #8,A5 ;Uncover Line_Num
ADDQ #8,A5 ;Uncover Line_Inc
MOVE.W CA_GTINT,A0 ;Signal get word integers
JSR (A0) ;do it
MOVE.W D5,D6 ;Restore D6 as Line_Inc # flag
SWAP D6 ;Put flag in high word
TST.L D0 ;Now check for CA_GTINT errors
BNE.S Close_All ;If error then end
;Now pull the parameters off the arithmetic stack
MOVE.W 0(A6,A1.L),D5 ;D5 = Line_Num
MOVE.W 2(A6,A1.L),D6 ;D6=Line_Inc
;3(a). Skip past number in input line
;Get a character
do_line
MOVE.L A2,A0 ;Put input channel Id in A0
skip_number
MOVEQ #-1,D3 ;Infinite timeout
MOVEQ #IO_FBYTE,D0 ;Signal get a byte
MOVE.L A1,D7 ;Preserve RI SP
TRAP #3 ;Do it
TST.L D0 ;Check for errors
BEQ.S Ok_3b ;If no errors then 3(b)
CMPI.B #ERR_EF,D0 ;Test if end of file
BNE.S Close_All ;if not then real error
CLR.L D0 ;ERR_EF means finished so OK
BRA.S Close_All ;OK so finish
;(b)  if not space then loop back to 3(a)
Ok_3b MOVE.L  D7,A1 ;Restore RI SP
CMPI.B #" ",D1 ;Test for a space character
BNE.S skip_number ;If not past then loop back
;(c)  Output Line_Num in ASCII
;Push Line_Num on "RI" stack
MOVE.W D5,0(A6,A1.L) ;Store Line_Num on RI stack
;Convert it to ASCII
LEA.L 2(A1),A0 ;A0=Address of buffer
MOVE.W CN_ITOD,A3 ;Get vector
JSR (A3) ;Call routine
;Converted D5 & it is now in the buffer
;to print Line_num, A0=Channel Id, A1=Base of buffer
;D2.W=number of bytes to send
;Output Line_Number
SUBA.L A1,A0 ;endptr-startptr = length
MOVE.W A0,D2 ;Set D2 as length for IO_SSTRG
MOVEQ #-1,D3 ;Infinite timeout
MOVE.L A4,A0 ;A0=Output channel Id
MOVEQ #IO_SSTRG,D0 ;Send a string of bytes
TRAP #4 ;All I/O ptrs relative to A6
TRAP #3 ;Send string
TST.L D0 ;Test for errors
BNE.S Close_All ;If any errors then end
;(d)  Set output character to a space & branch to 4(c)
MOVEQ #-1,D3 ;Set infinite timeout
MOVEQ #" ",D1 ;Sending a space char
BRA.S send_char ;& branch to 4(c)
;4(a). Copy the rest of the line
;Get a character from the input channel
;If not error then 4(c)
line_copy
MOVE.L A2,A0 ;A0=Input channel Id
MOVEQ #IO_FBYTE,D0 ;Signal fetch a byte
MOVEQ #-1,D3 ;Infinite timeout
TRAP #3 ;Do it
TST.L D0 ;Test for errors
BEQ.S lico_ok ;If no errors then ok
;Otherwise ...
CMPI.B #ERR_EF,D0 ;Is error end of file ?
BNE.S Close_All ;If real error then end
CLR.L D0 ;Finishing so no error
BRA.S Close_All ;End of procedure
;(c)  Put character on the output channel
lico_ok MOVE.L A4,A0 ;A0=Output channel Id
;D1,D3 already set up
send_char
MOVEQ #IO_SBYTE,D0 ;Signal send a byte
TRAP #3 ;Send the byte
TST.L D0 ;Test for errors
BNE.S Close_All ;If errors then end
;(d) if character is a CHR$(10) then loop back to 3
CMPI.B #$0A,D1 ;At the end of the line ?
BNE.S line_copy ;Copy rest of the line
ADD.W D6,D5 ;Line_num=Line_Num+Line_Inc
MOVE.L D7,A1 ;Restore A1 as RI SP
BRA.S do_line ;Handle the next line

;Common routines
Close_All
BSR.S clr_rel_A6 ;Clear up after failed SB I/O
BSR.S Clo_src ;If neccesary close source
BSR.S Clo_des ;If neccesary close dest
RTS
Close MOVE.L  D0,D7 ;Preserve error code
MOVEQ #IO_CLOSE,D0 ;Select close
MOVEQ #-1,D3 ;Infinite timeout
TRAP #2 ;Close the channel
MOVE.L D7,D0 ;Restore error code
err_end RTS ;Return To Sender
clo_src MOVE.L  A2,A0 ;Select source channel Id
SWAP D5 ;Get source # flag in low byte
TST.B D5 ;If there wasn't a # then you
BEQ.S Close ;need to close the channel
RTS ;Return To Sender
clo_des MOVE.L A4,A0 ;Select desination channel Id
SWAP D6 ;Get dest # flag in low byte
TST.B D6 ;If there wasn't a # then you
BEQ.S Close ;need to close the channel
RTS ;Return To Sender

;If someone writes a new version of Qdos that uses screen 1 then the
;system variables will have moved. So clr_rel_A6 uses MT.INF to get
;the base of the sys vars & if it  doesn't work then let me know
clr_rel_A6
MOVE.L D0,D7 ;Preserve error status
MOVEQ #MT_INF,D0 ;Signal routine
TRAP #1 ;Get system information
LEA.L $64(A0),A3 ;A3=addr of SV.JBPNT
MOVE.L (A3),A3 ;A3=addr of Job Control Block
BCLR #7,$16(A3) ;Clear RELA6?
MOVE.L D7,D0 ;Restore error status
RTS ;didn't affect it).
;Routine OPENER. Will look  at the parameter data & if there is a #
;then it will get a word integer & attempt to get the Qdos Id of a
;SuperBasic channel otherwise it will get a string & open a channel
;to that.
;Entry
;D3 Open type 0 old exclusive,1 old shared,2 new exclusive,3 new over
;write,4 open directory
;A3 & A5 point to the info on one parameter (relative to A6)
;A1 Arithmetic stack pointer
;Exit
;D0 error
;D2 flags channel is a Super Basic channel (so don't close at end)
;A0 when no error will hold the Qdos Id
OPENER BTST #7,$1(A6,A3.L) ;Testing for presence of #
BEQ.S chn_string ;BRAnchif its a string
MOVE.W CA_GTINT,A0 ;Get vector
JSR (A0) ;Get word integer
BNE.S opn_err ;If error then end
;Find Qdos Id of SuperBasic channel Id at 0(A6,A1.L)
MOVE.L BV_CHBAS(A6),D2 ;Base of SB chan table rel A6
MOVEQ #$28,D1 ;D1=Size of channel length
MULU 0(A6,A1.L),D1 ;Offset = Index x Size
ADD.L D1,D2 ;A0 ptr to table entry rel A6
MOVEQ #ERR_NO,D0 ;Signal "channel not open"
CMP.L BV_CHP(A6),D2 ;If outside table ...
BGE.S opn_err ;.. then end with error
MOVE.L 0(A6,D2.L),D3 ;Collect channel Id
MOVE.L D3,A0 ;Now put Id where its wanted
;I need it in A0 but dump it in D3 because I want the data transfer
;to affect the CCR (moving to A0 wouldn't)
BLT.S opn_err ;If closed then end with error
ST D2 ;ST always sets to $FF
MOVEQ #0,D0 ;No errors
opn_err TST.L D0 ;Signal error status
RTS ;Return To Sender
;Open a channel for the filename at 0(A6,A1.L)
chn_string
MOVEM.L D3/A2,-(A7)
MOVE.W CA_GTSTR,A0 ;Get vector
JSR (A0) ;Get a string
MOVEM.L (A7)+,D3/A2
TST.L D0 ;Check for errors
BNE.S ops_err
MOVEQ #IO_OPEN,D0 ;Signal IO.OPEN
MOVE.L A1,A0 ;A0=address of name
MOVEQ #0,D1 ;D1=SuperBasic job Id
MOVE.L A1,D7 ;Preserve RI SP
TRAP #4 ;I/O operation relative to A6
TRAP #2 ;Open the channel
TST.L D0 ;Test for errors
BNE.S clr_rel_A6 ;If errors then end
SF D2 ;SF always clears to 0
MOVE.L D7,A1 ;Restore RI SP
ops_err RTS ;Return To Sender
